<!doctype html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>reveal.js</title>

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">

    <style>
        .reveal pre {
            font-size: 0.45em;
        }

        .reveal pre.small {
            font-size: 0.3em;
        }

        .reveal pre.medium {
            font-size: 0.375em;
        }

        .reveal pre code {
            max-height: 500px;
        }
    </style>
    <!--
    agate
    androidstudio
    atom-one-dark
    github
    railscasts
    monokai-sublime
    tomorrow
    -->
    <!-- Theme used for syntax highlighted code -->
    <!--link rel="stylesheet" href="plugin/highlight/monokai.css" id="highlight-theme"-->

    <link rel="stylesheet" href="http://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.0.3/styles/monokai-sublime.min.css">

</head>
<body>
<div class="reveal">
    <div class="slides">
        <section>
            How I write Unit Test
        </section>
        <section>
            TODO
            @whoami
        </section>
        <section data-markdown>
            <textarea data-template>
                # Summary

                - PHPUnit + PHP7
                - DataProviders
                - Mocking
                - Coverage + Logging
                - Gherkin
            </textarea>
        </section>
        <section data-markdown>
            <textarea data-template>
                ## Disclaimer

                This presentation isn't about how to write good tests.

                It's about what I consider (my) PHPUnit best practices.

                <small>They are highly opinionated&trade;.</small>
            </textarea>
        </section>
        <section>
            <h2>PHPUnit + PHP7</h2>
        </section>
        <section>Example
<pre class="php small"><code data-line-numbers>
final class Math
{
    public function add(int ...$values): int
    {
        return array_sum($values);
    }

    public function multiply($a, int $b): int
    {
        if (!is_int($a)) {
            throw new \TypeError('First parameter must be int');
        }

        return $a * $b;
    }

    public function divide(int $dividend, int $divisor): float
    {
        if ($divisor === 0) {
            throw new \InvalidArgumentException('Divisor cannot be 0');
        }

        return $dividend / $divisor;
    }

    public function pow(int $base): int
    {
        return $base ** 2;
    }
}</code></pre>
        </section>
        <section data-markdown>
            <textarea data-template>
                ## Reminder

                Testing code isn't application code.

                We don't need to follow the same rules.
            </textarea>
            <aside class="notes">
                When writing PHPUnit code we need to differentiate two types:
                - PHPUnit extensions => code
                - PHPUnit tests => executable recipe
            </aside>
        </section>
        <section>
            Subject Under Test
<pre class="php"><code data-trim data-noescape data-line-numbers="|5|1">
class MathTest extends TestCase
{
    public function testMultiply()
    {
        $sut = new Math();
        $result = $sut->multiply(2, 3);

        $this->assertSame(6, $result);
    }
}</code></pre>
        </section>
        <section>
            camelCase vs. snake_case
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|3|8">
class MathTest extends TestCase
{
    public function testDivideThrowsIfDivisorIsZero()
    {
        // ...
    }

    public function test_divide_throws_if_divisor_is_zero()
    {
        // ...
    }
}</code></pre>
        </section>
        <section>
            Return types
            <pre class="php"><code data-trim data-noescape data-line-numbers="|3">
class MathTest extends TestCase
{
    public function testMultiply(): void
    {
        $sut = new Math();
        $result = $sut->multiply(2, 3);

        $this->assertSame(6, $result);
    }
}
            </code></pre>
        </section>
        <section>
            Return type + @depends
            <pre class= php"><code data-trim data-noescape data-line-numbers="|3,12,14">
class MathTest extends TestCase
{
    public function testConstructor(): Math
    {
        $sut = new Math();
        $this->assertInstanceOf(Math::class, $sut);

        return $sut;
    }

    /**
     * @depends testConstructor
     */
    public function testMultiply(Math $sut): void
    {
        $result = $sut->multiply(2, 3);

        $this->assertSame(6, $result);
    }
}
            </code></pre>
            <aside class="notes">
                We can potentially call the constructor always + state?
            </aside>
        </section>
        <section>
            Argument types
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|4,6">
class MathTest extends TestCase
{
    /**
     * $a = '1' // TypeError
     */
    public function testMultiply(int $a, int $b, int $c): void
    {
        $sut = new Math();

        $this->expectException(\TypeError::class);
        $sut->multiply($a, $b);
    }
}
            </code></pre>
        </section>
        <section>
            Positive vs. Negative cases
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|3-9|11-17">
class MathTest extends TestCase
{
    public function testMultiply(int $a, int $b, int $c): void
    {
        $sut = new Math();
        $result = $sut->multiply($a, $b);

        $this->assertSame($c, $result);
    }

    public function test_multiply_throws_if_argument_not_int($a, $b): void
    {
        $sut = new Math();

        $this->expectException(\TypeError::class);
        $sut->multiply($a, $b);
    }
}
            </code></pre>
        </section>
        <section>
            <h2>Data Providers</h2>
        </section>
        <section>
            What are data providers?
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|4-5,7,12,19">
class MathTest extends TestCase
{
    /**
     * @dataProvider dataProviderMultiply
     * @dataProvider providerMultiply
     */
    public function testMultiply(int $a, int $b, int $c): void
    {
        // ...
    }

    public function dataProviderMultiply(): array
    {
        return [
            [1, 1, 1],
        ];
    }

    public function providerMultiply(): array
    {
        return [
            [-4, 2, -2],
        ];
    }
}
            </code></pre>
        </section>
        <section>
            dataProvider vs. provider<br />
            prefix vs. suffix
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|3,8,13,18|3">
class MathTest extends TestCase
{
    public function dataProviderMultiply(): array
    {
        // ...
    }

    public function providerMultiply(): array
    {
        // ...
    }

    public function multiplyDataProvider(): array
    {
        // ...
    }

    public function multiplyProvider(): array
    {
        // ...
    }
}
                </code></pre>
            <aside class="notes">
                The convention for tests methods is to be prefixed by tests,
                my preference is for prefix and also dataProvider over provider.
                Using a prefix comes along nicely with how I create mocks, which I will show you shortly
            </aside>
        </section>
        <section>
            Expected value first
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|6,11,18-22|9,11">
class MathTest extends TestCase
{
    /**
     * @dataProvider dataProviderMultiply
     */
    public function testMultiply(int $expected, int $a, int $b): void
    {
        // ...
        $actual = $sut->multiply($a, $b);

        $this->assertSame($expected, $actual);
    }

    public function dataProviderMultiply(): array
    {
        return [
            [1, 1, 1],
            [
                4,
                2,
                2
            ],
        ];
    }
}
            </code></pre>
        </section>
        <section>
            Variadic
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|6,11,17-19">
class MathTest extends TestCase
{
    /**
     * @dataProvider dataProviderMultiply
     */
    public function testMultiply(int $expected, int ...$values): void
    {
        // ...
        $actual = $sut->multiply(...$values);

        $this->assertSame($expected, $actual);
    }

    public function dataProviderMultiply(): array
    {
        return [
            [1, 1, 1, 1, 1],
            [8, 2, 2, 2],
            [9, 3, 3],
        ];
    }
}
            </code></pre>
        </section>
        <section>
            Data Provider + @depends
            <pre class="php medium fragment"><code data-trim data-noescape data-line-numbers="|4-5,7">
class MathTest extends TestCase
{
    /**
     * @dataProvider dataProviderMultiply
     * @depends testConstructor
     */
    public function testMultiply(int $expected, int $a, int $b, Math $suj): void
    {
        $actual = $sut->multiply($a, $b);

        $this->assertSame($expected, $actual);
    }

    public function dataProviderMultiply(): array
    {
        return [
            [1, 1, 1],
            [4, 2, 2],
        ];
    }
}
            </code></pre>
        </section>
        <section>
            Named datasets
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|17-18">
class MathTest extends TestCase
{
    /**
     * @dataProvider dataProviderMultiply
     */
    public function testMultiply(int $expected, int $a, int $b): void
    {
        // ...
        $actual = $sut->multiply($a, $b);

        $this->assertSame($expected, $actual);
    }

    public function dataProviderMultiply(): array
    {
        return [
            'positive * positive' => [-1, 1, 1],
            'negative * negative' => [4, -2, -2],
        ];
    }
}
                </code></pre>
            <pre class="none fragment"><code>
1) MathTest::testMultiply with data set &quot;positive * positive&quot; (-1, 1, 1)
Failed asserting that 1 is identical to -1.
            </code></pre>
            <aside class="notes">
                Sadly, the dataset name isn't displayed on testdox.
                That's why I recommend the CLI output to be the default PHPUnit,
                but produce also testdox reports are part of your testing artifacts.
            </aside>
        </section>
        <section>
            Where data providers go?
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|6,15-16,18">
class MathTest extends TestCase
{
    /**
     * @dataProvider dataProviderMultiply
     */
    public function testMultiply(int $expected, int $a, int $b): void
    {
        // ...
        $actual = $sut->multiply($a, $b);

        $this->assertSame($expected, $actual);
    }

    /**
     * Below the testing method/s
     * or at the bottom of the class if 2+ methods use it
     */
    public function dataProviderMultiply(): array
    {
        return [
            'positive * positive' => [-1, 1, 1],
            'negative * negative' => [4, -2, -2],
        ];
    }
}
            </code></pre>
            <aside class="notes">
                My preference is immediately below the method/s (2) to be tested.
                If there is more than 1-2 methods that uses them, I will move them to the bottom of the test class.
            </aside>
        </section>
        <section>
            Data Provider traits
            <pre class="php small"><code data-trim data-noescape data-line-numbers="">
trait DataProvider
{
    public function dataProviderNull(): array
    {
        return [
            'null' => [null],
        ];
    }

    public function dataProviderBooleans(): array
    {
        return [
            'boolean true'  => [true],
            'boolean false' => [false],
        ];
    }

    public function dataProviderInts(): array
    {
        return [
            'zero'        => [0],
            'positive'    => [10],
            'negative'    => [-7],
            'PHP_INT_MAX' => [PHP_INT_MAX],
            'PHP_INT_MIN' => [PHP_INT_MIN],
        ];
    }
}
            </code></pre>
        </section>
        <section>
            Generators
            <pre class="php small"><code data-trim data-noescape data-line-numbers="">
final class JsonTest extends TestCase
{
    /**
     * @dataProvider dataProviderSerialize
     */
    public function testSerialize(array $expected, Money $money): void
    {
        $sut = new Json();
        $actual = $sut->serialize($money);
        $this->assertSame($expected, $actual);
    }

    public function dataProviderSerialize(): Generator
    {
        $money = new Money('GBP', 1.23);
        yield 'Pounds: 1.23' => [
            [
                'currency' => $money->getCurrency(),
                'amount'   => $money->getAmount(),
            ],
            $money
        ];

        $money = new Money('EUR', 4.56);
        yield 'Euros: 4.56' => [
            [
                'currency' => $money->getCurrency(),
                'amount'   => $money->getAmount(),
            ],
            $money
        ];
    }
}
            </code></pre>
        </section>
        <section>
            <h2>Mocking</h2>
        </section>
        <section>
            Example
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="">
final class Dummy
{
    private ConditionInterface $first;

    private ConditionInterface $second;

    public function __construct(
        ConditionInterface $first,
        ConditionInterface $second
    ) {
        $this->first = $first;
        $this->second = $second;
    }

    public function exectue(): int
    {
        if ($this->first->result()) {
            return 1;
        }

        return ($this->second->result()) ? 2 : 0;
    }
}
            </code></pre>
        </section>
        <section>
            Multiline constructors & methods
            <pre class="php"><code data-trim data-noescape data-line-numbers="|5-8|6-7">
final class DummyTest extends TestCase
{
    public function testConstructor(): void
    {
        $sut = new Dummy(
            $this->createMock(Condition::class),
            $this->createMock(Condition::class),
        );

        $this->assertInstanceOf(Dummy::class, $sut);
    }
            </code></pre>
        </section>
        <section>
            Private methods to create Mocks
            <pre class="php small"><code data-trim data-noescape data-line-numbers="|5-8,20-26">
final class DummyTest extends TestCase
{
    public function testFirstBranch(): void
    {
        $first = $this->createMock();
        $first->expects($this->atLeastOnce())
                ->method('result')
                ->willReturn($result);

        $sut = new Dummy(
            $first,
            $this->createCondition(),
        );

        $result = $sut->exectue();

        $this->assertSame(1, $result);
    }

    /**
     * @return Condition&MockObject
     */
    private function createCondition(): ConditionInterface
    {
        return $this->createMock(Condition::class);
    }
}
            </code></pre>
        </section>
        <section>
            Repetitive functionality
            <pre class="php small"><code data-trim data-noescape data-line-numbers="|6,18,22-26">
final class DummyTest extends TestCase
{
    public function testFirstBranch(): void
    {
        $sut = new Dummy(
            $this->createCondition(true),
            $this->createCondition(),
        );

        $result = $sut->exectue();

        $this->assertSame(1, $result);
    }

    /**
     * @return Condition&MockObject
     */
    private function createCondition(bool $result = null): ConditionInterface
    {
        $mock = $this->createMock(Condition::class);

        if ($result !== null) {
            $mock->expects($this->atLeastOnce())
                ->method('result')
                ->willReturn($result);
        }

        return $mock;
    }
}
            </code></pre>
        </section>
        <section>
            once vs atLeastOnce
            <pre class="php"><code data-trim data-noescape data-line-numbers="|6,11">
final class DummyTest extends TestCase
{
    public function testNotWorkingAsExpected(): void
    {
        $this->first->expects($this->atLeastOnce())
            ->method('result')
            ->willReturn(true);

        $this->second->expects($this->never())
            ->method('result')
            ->willReturn(true);

        $result = $this->sut->exectue();

        $this->assertSame(1, $result);
    }
}
            </code></pre>
        </section>
        <section>
            Stateful vs. stateless tests
            <pre class="php small"><code data-trim data-noescape data-line-numbers="|10-20,22-30">
final class DummyTest extends TestCase
{
    private Dummy $sut;

    /** @var Condition&MockObject */
    private Condition $first;
    /** @var Condition&MockObject */
    private Condition $second;

    public function setUp(): void
    {
        $this->first  = $this->createCondition();
        $this->second = $this->createCondition();

        // Problem! Constructor can't be tested on isolation
        $this->sut = new Dummy(
            $this->first,
            $this->second
        );
    }

    public function testFirstBranchWithState(): void
    {
        $this->first->expects($this->atLeastOnce())
            ->method('result')
            ->willReturn(true);

        $result = $this->sut->exectue();
        $this->assertSame(1, $result);
    }
}
            </code></pre>
        </section>
        <section>
            Stateful vs. stateless tests
            <pre class="php small"><code data-trim data-noescape data-line-numbers="|8-12,14-22,24-32">
final class DummyTest extends TestCase
{
    /** @var Condition&MockObject */
    private Condition $first;
    /** @var Condition&MockObject */
    private Condition $second;

    public function setUp(): void
    {
        $this->first  = $this->createCondition();
        $this->second = $this->createCondition();
    }

    public function testConstructor(): Dummy
    {
        $sut = new Dummy(
            $this->first,
            $this->second
        );
        $this->assertInstanceOf(Dummy::class, $sut);
        return $sut;
    }

    // Problem! We can't depend on testConstructor as the dependency isn't ready
    public function testFirstBranchWithState(): void
    {
        $this->first->method('result')
            ->willReturn(true);

        $result = $this->testConstructor()->exectue();
        $this->assertSame(1, $result);
    }
}
            </code></pre>
        </section>
        <section>
            Mock factory
            <pre class="php small"><code data-trim data-noescape data-line-numbers="|10,20">
trait MockFactory
{
    abstract protected function createMock($originalClassName): MockObject;

    private function createServerRequest(): ServerRequestInterface
    {
        return new ServerRequest();
    }

    private function createHandler(): RequestHandlerInterface
    {
        return new class implements RequestHandlerInterface {
            public function handle(ServerRequestInterface $request): ResponseInterface
            {
                return new Response();
            }
        };
    }

    private function createHandlerMock(ResponseInterface $response): RequestHandlerInterface
    {
        $mock = $this->createMock(RequestHandlerInterface::class);

        $mock->method('handle')
            ->willReturn($response);

        return $mock;
    }
}
                </code></pre>
            <aside class="notes">
                We don't need to use create*Mock, as we might not always have mocks.
                The $sut doesn't care if they are mocks or not.
            </aside>
        </section>
        <section>
            Anonymous classes
            <pre class="php small"><code data-trim data-noescape data-line-numbers="10-18">
trait MockFactory
{
    abstract protected function createMock($originalClassName): MockObject;

    private function createServerRequest(): ServerRequestInterface
    {
        return new ServerRequest();
    }

    private function createHandler(): RequestHandlerInterface
    {
        return new class implements RequestHandlerInterface {
            public function handle(ServerRequestInterface $request): ResponseInterface
            {
                return new Response();
            }
        };
    }

    private function createHandlerMock(ResponseInterface $response): RequestHandlerInterface
    {
        $mock = $this->createMock(RequestHandlerInterface::class);

        $mock->method('handle')
            ->willReturn($response);

        return $mock;
    }
}
                </code></pre>
            <aside class="notes">
                For simply classes, sometimes is easier just to implement a class than mocking it.
            </aside>
        </section>
        <section>
            Anonymous classes for speed
            <pre class="php small"><code data-trim data-noescape data-line-numbers="">
final class DepositHandlerTest extends TestCase
{
    private function createAccountRepository(): AccountRepository
    {
        $accounts = [
            '1' => new Account(1000.00),
        ];

        /** In Memory repository */
        return new class ($accounts) implements AccountRepository
        {
            private array $accounts;

            /**
             * @param array&lt;string,Account&gt; $accounts
             */
            public function __construct(array $accounts)
            {
                $this->accounts = $accounts;
            }

            public function find(string $id): ?Account
            {
                if (!isset($this->accounts[$id])) {
                    return null;
                }

                return $this->accounts[$id];
            }
        };
    }
}
            </code></pre>
        </section>
        <section>
            <h2>Coverage + Logging</h2>
        </section>
        <section>
            @coverage directive
            <pre class="php"><code data-trim data-noescape data-line-numbers="|2">
/**
 * @covers \App\Dummy
 */
final class DummyTest extends TestCase
{
    public function testFirstBranch(): void
    {
        $sut = new Dummy(
            $this->createCondition(true),
            $this->createCondition(),
        );

        $result = $sut->exectue();

        $this->assertSame(1, $result);
    }
}
            </code></pre>
        </section>
        <section>
            Discover untested branches
            <img src="assets/coverage.png" />
        </section>
        <section>
            Ternary operator
            <pre class="php small"><code data-trim data-noescape data-line-numbers="|14,25">
/**
 * @covers \App\Dummy
 */
final class DummyTest extends TestCase
{
    public function testFirstBranch(): void
    {
        $sut = new Dummy(
            $this->createCondition(true),
            $this->createCondition(),
        );

        $result = $sut->exectue();
        $this->assertSame(1, $result);
    }

    public function testSecondBranch(): void
    {
        $sut = new Dummy(
            $this->createCondition(),
            $this->createCondition(true),
        );

        $result = $sut->exectue();
        $this->assertSame(2, $result);
    }
}
            </code></pre>
        </section>
        <section>
            Ternary operator is evil!
            <img src="assets/coverage-ternary.png" />
        </section>
        <section>
            Use XML configuration over composer.json
            <pre class="xml small"><code data-trim data-noescape data-line-numbers="|5-6|21">
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;phpunit xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:noNamespaceSchemaLocation="https://schema.phpunit.de/8.5/phpunit.xsd"
         bootstrap="../vendor/autoload.php"
         forceCoversAnnotation="true"
         beStrictAboutCoversAnnotation="true"
         ...&gt;
    &lt;testsuites&gt;
        ...
    &lt;/testsuites&gt;

    &lt;filter&gt;
        &lt;whitelist processUncoveredFilesFromWhitelist="true"&gt;
            &lt;directory suffix=".php"&gt;../src&lt;/directory&gt;
        &lt;/whitelist&gt;
    &lt;/filter&gt;

    &lt;logging&gt;
        &lt;log type="junit" target="../output/results/unit.xml" /&gt;
        &lt;log type="testdox-text" target="../output/log/unit.txt" /&gt;
        &lt;log type="coverage-php" target="../output/coverage/unit.cov" /&gt;
    &lt;/logging&gt;
&lt;/phpunit&gt;
            </code></pre>
        </section>
        <section>
            Merge coverage from different test suites
            <pre class="xml small"><code data-trim data-noescape data-line-numbers="5">
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;phpunit xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"&gt;
    ...
    &lt;logging&gt;
        &lt;log type="coverage-php" target="../output/coverage/unit.cov" /&gt;
    &lt;/logging&gt;
&lt;/phpunit&gt;
            </code></pre>
            <pre class="xml small"><code data-trim data-noescape data-line-numbers="5">
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;phpunit xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"&gt;
    ...
    &lt;logging&gt;
        &lt;log type="coverage-php" target="../output/coverage/integration.cov" /&gt;
    &lt;/logging&gt;
&lt;/phpunit&gt;
            </code></pre>
            <pre class="small"><code data-trim data-noescape data-line-numbers="">
phpcov merge output/coverage/ --clover output/coverage/clover.xml --html output/coverage/html
            </code></pre>
        </section>

        <section>
            Testdox
            <pre class="small"><u style="text-decoration-style:single">Math (Tests\Unit\Math\Math)</u>
 <font color="#4E9A06">✔</font> Constructing Math class <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Power: <font color="#06989A">1</font> ^ 2 = <font color="#06989A">1</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Power: <font color="#06989A">2</font> ^ 2 = <font color="#06989A">4</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Power: <font color="#06989A">-3</font> ^ 2 = <font color="#06989A">9</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Power: <font color="#06989A">0</font> ^ 2 = <font color="#06989A">0</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Multiply: <font color="#06989A">3</font> * <font color="#06989A">2</font> = <font color="#06989A">6</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Multiply: <font color="#06989A">9</font> * <font color="#06989A">-9</font> = <font color="#06989A">-81</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Multiply: <font color="#06989A">-3</font> * <font color="#06989A">-2</font> = <font color="#06989A">6</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Multiply throws if argument not int <font color="#AAA">with data set</font> <font color="#06989A">2</font> <font color="#4E9A06"> 4 ms</font>
 <font color="#4E9A06">✔</font> Multiply throws if argument not int <font color="#AAA">with data set</font> <font color="#06989A">0</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Multiply throws if argument not int <font color="#AAA">with</font> <font color="#06989A">null</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Multiply throws if argument not int <font color="#AAA">with data set</font> <font color="#06989A">1</font> <font color="#4E9A06"> 2 ms</font>
 <font color="#C4A000">✘</font> Addition (variadic): sum(<font color="#06989A">3</font>) = <font color="#06989A">5</font> <font color="#C4A000"> 2 ms</font>
   <font color="#C4A000">┐</font>
   <font color="#C4A000">├</font> <span style="background-color:#C4A000"><font color="#2E3436">Error: Call to undefined method App\Math\Math::addVariadic()</font></span>
   <font color="#C4A000">│</font>
   <font color="#C4A000">╵</font> /app/tests/unit/Math/MathTest.php:<font color="#3465A4">51</font>
   <font color="#C4A000">┴</font>

 <font color="#C4A000">✘</font> Addition (variadic): sum(<font color="#06989A">9</font>) = <font color="#06989A">0</font> <font color="#C4A000"> 1 ms</font>
   <font color="#C4A000">┐</font>
   <font color="#C4A000">├</font> <span style="background-color:#C4A000"><font color="#2E3436">Error: Call to undefined method App\Math\Math::addVariadic()</font></span>
   <font color="#C4A000">│</font>
   <font color="#C4A000">╵</font> /app/tests/unit/Math/MathTest.php:<font color="#3465A4">51</font>
   <font color="#C4A000">┴</font>

 <font color="#C4A000">✘</font> Addition (variadic): sum(<font color="#06989A">-3</font>) = <font color="#06989A">-5</font> <font color="#C4A000"> 2 ms</font>
   <font color="#C4A000">┐</font>
   <font color="#C4A000">├</font> <span style="background-color:#C4A000"><font color="#2E3436">Error: Call to undefined method App\Math\Math::addVariadic()</font></span>
   <font color="#C4A000">│</font>
   <font color="#C4A000">╵</font> /app/tests/unit/Math/MathTest.php:<font color="#3465A4">51</font>
   <font color="#C4A000">┴</font>

            </pre>
        </section>
        <section>
            Testdox
            <pre class="php"><code data-trim data-noescape data-line-numbers="">
class MathTest extends TestCase
{
    // Will output: Multiply
    public function testMultiply(int $a, int $b, int $c): void
    {
        // ...
    }

    // Will output: Multiply throws if argument not int
    public function test_multiply_throws_if_argument_not_int($a, $b): void
    {
        // ...
    }
}
            </code></pre>
        </section>
        <section>
            Testdox
            <pre class="php"><code data-trim data-noescape data-line-numbers="|4,6">
class MathTest extends TestCase
{
    /**
     * Supports substitutions.
     *
     * @testdox Addition: $a * $b = $c
     */
    public function testMultiply(int $a, int $b, int $c): void
    {
        // ...
    }
}
            </code></pre>
            <pre class="fragment medium"><u style="text-decoration-style:single">Math (Tests\Unit\Math\Math)</u>
 <font color="#4E9A06">✔</font> Multiply: <font color="#06989A">3</font> * <font color="#06989A">2</font> = <font color="#06989A">6</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Multiply: <font color="#06989A">9</font> * <font color="#06989A">-9</font> = <font color="#06989A">-81</font> <font color="#4E9A06"> 1 ms</font>
 <font color="#4E9A06">✔</font> Multiply: <font color="#06989A">-3</font> * <font color="#06989A">-2</font> = <font color="#06989A">6</font> <font color="#4E9A06"> 1 ms</font>
   ...
            </pre>
        </section>
        <section>
            <h2>Domain Specific Assertions</h2>
        </section>
        <section>
            <h2>Bonus tip!</h2>
        </section>
        <section>
            Gherkin
            <pre class="php medium"><code data-trim data-noescape data-line-numbers="|5,10,13">
final class DummyTest extends TestCase
{
    public function testFirstBranchWithState(): void
    {
        // Given the first condition is true
        $this->first->expects($this->atLeastOnce())
            ->method('result')
            ->willReturn(true);

        // When we execute dummy service
        $result = $this->sut->exectue();

        // Then the result is 1
        $this->assertSame(1, $result);
    }
}
            </code></pre>
        </section>
        <section>
            <h2>Questions?</h2>
        </section>
    </div>
    </div>
</div>

<script src="dist/reveal.js"></script>
<script src="plugin/notes/notes.js"></script>
<script src="plugin/markdown/markdown.js"></script>
<script src="plugin/highlight/highlight.js"></script>
<script>
    // More info about initialization & config:
    // - https://revealjs.com/initialization/
    // - https://revealjs.com/config/
    Reveal.initialize({
        hash: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [RevealMarkdown, RevealHighlight, RevealNotes]
    });
</script>
</body>
</html>
